//---------------------------------------------------------------------------

#ifndef FServerH
#define FServerH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <FMX.Controls.hpp>
#include <FMX.Forms.hpp>
#include <FMX.Controls.Presentation.hpp>
#include <FMX.StdCtrls.hpp>
#include <FMX.Types.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdCustomTCPServer.hpp>
#include <IdTCPServer.hpp>
#include <FMX.Memo.hpp>
#include <FMX.ScrollBox.hpp>
#include <IdContext.hpp>
//---------------------------------------------------------------------------
const int GUEST_CLIENT_PORT = 20010;

class TFMicroServer : public TForm
{
__published:	// Composants grs par l'EDI
	TIdTCPServer *IdTCPServer;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *clients_connected;
	TPanel *Panel1;
	TMemo *messagesLog;
	TButton *btn_start;
	TButton *btn_stop;
	TButton *btn_clear;
	void __fastcall IdTCPServerConnect(TIdContext *AContext);
	void __fastcall IdTCPServerDisconnect(TIdContext *AContext);
	void __fastcall IdTCPServerExecute(TIdContext *AContext);
	void __fastcall IdTCPServerStatus(TObject *ASender, const TIdStatus AStatus, const UnicodeString AStatusText);
	void __fastcall btn_clearClick(TObject *Sender);
	void __fastcall btn_startClick(TObject *Sender);
	void __fastcall btn_stopClick(TObject *Sender);

private:	// Dclarations utilisateur
	void __fastcall ShowNumberOfClients(bool p_disconnected);
	void __fastcall BroadcastMessage(UnicodeString p_message);
	void __fastcall Display(UnicodeString p_sender, UnicodeString p_message);
	UnicodeString __fastcall GetNow();

public:		// Dclarations utilisateur
	__fastcall TFMicroServer(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFMicroServer *FMicroServer;
//---------------------------------------------------------------------------
#endif
